Subject: Re: bug#57962: 29.0.50; Odd font choices

From: Po Lu <[email-masked]>
Date: Mon, 17 Oct 2022 20:58:58 +0800

Lars Ingebrigtsen <[email-masked]> writes:

> Eli Zaretskii <[email-masked]> writes:
>
>> Maybe with "fixed-*" fonts this is so.  But isn't True Type fonts
>> scalable, so that we can request any size and get what we request?
>
> We can request "size 12", but how big that is varies greatly by font,
> unfortunately.  The font people haven't standarised this -- because of
> the origins of font tech, and that "optical size" can vary even with the
> same physical sizes.  So it's a mess, basically.
>
>> Is that because ":spacing 'm" doesn't work (it seems to work for me)?
>> If so, I think we should try fixing that instead of introducing new
>> wizardry.
>
> This:
>
> (defface fixed-pitch
>   `((t :font ,(font-spec :spacing 'M)))
>   "The basic fixed-pitch face."
>   :group 'basic-faces)
>
> Made Emacs choose this font:
>
>     ftcrhb:-GOOG-Noto Sans CJK KR-regular-normal-normal-*-45-*-*-*-*-0-iso10646-1 (#x24)
>
> Which is not a monospace font (and is a different font family than the
> `default' face uses:
>
>     ftcrhb:-DAMA-Ubuntu Mono-regular-normal-normal-*-45-*-*-*-m-0-iso10646-1 (#x47)
>
> So that seems to be another bug in this area?
>
> I also tried this in Emacs 28 and earlier, and it does nothing there, so
> it's broken in a different way on master than in Emacs 28.

I don't see that here, could you please try to bisect to the change that
causes the bug?

I suspect one of the changes to xfaces.c that happened a month or so
ago, so if bisecting isn't convenient for you just try reverting
xfaces.c to progressively earlier revisions and see where (and if) that
bug disappears.